using System;

namespace _12_MultipleInterfaces
{   
    interface IVolumeControl
    {
        int Current
        {
            get;
        }
    }
	
    interface IChannelControl
    {
        int Current
        {
            get;
        }
    }

    public class Radio : IVolumeControl, IChannelControl
    {
        int IVolumeControl.Current
        {
            get
            {
                return 1;
            }
        }
        int IChannelControl.Current
        {
            get
            {
                return 2;
            }
        }
    }

    class Class1
    { 
        [STAThread]
        static void Main(string[] args)
        {
           IChannelControl radioDial = (IChannelControl) new Radio();
           Console.WriteLine( "Current Channel = {0}", radioDial.Current );
        }
    }
}
