using System;

namespace _4_Operators
{
	/// <summary>
	/// 
	/// </summary>
	public class Television
	{
	        /// <summary>
            /// current channel tv is set to
            /// </summary>
        private static int channel = 2;
        private const int maxChannels = 200;
        
        /// <summary>
        /// changes the channel to a specified channel
        /// </summary>
        public bool ChangeChannel(int newChannel)
        {
            if( newChannel > maxChannels )
                return false;

            channel = newChannel;

            return true;
        }

        public static Television operator ++( Television tv )
        {
            tv.ChangeChannel(++channel);
            return tv;
        }

        public static implicit operator Television( int from )
        {
            Television tv = new Television();
            tv.ChangeChannel( from );
            return tv;
        }

        public int GetChannel()
        {
            return channel;
        }
	}

}
