using System;

namespace _2_Formatting
{
	class Class1
	{
	    [STAThread]
		static void Main(string[] args)
		{
            string s;
            int x = 2, y = 4;
   
            //which one is easier to read?
            s = String.Format("x={0}, y={1}, {0}+{1}={2}", x, y, x+y );
            s = "x=" + x + ",y=" + y + ", " + x + "+" + y + "=" + (x+y);

            double[] numArray = {2, 5, 4.5, 45.43, 200000};

            // diplay orginal array
            Console.WriteLine( "Array\n-----" );
            foreach( double num in numArray )
            {
                Console.Write( "{0}\t", (float)num );
            }

            // format in lowercase hex
            Console.WriteLine( "\n\nHex (lower)\n-----------" );
            foreach( double num in numArray )
            {
                Console.Write( "0x{0:x8}\t", (int)num );
            }

            // format in uppercase hex
            Console.WriteLine( "\n\nHex (upper)\n-----------" );
            foreach( double num in numArray )
            {
                Console.Write( "0x{0:X8}\t", (int) num );
            }
            
            // format as currency
            Console.WriteLine( "\n\nCurrency\n--------" );
            foreach( double num in numArray )
            {
                Console.Write( "{0:C}\t", num );
            }

            // format as custom
            Console.WriteLine( "\n\nCustom\n------" );
            foreach( double num in numArray )
            {
                Console.WriteLine( "{0:$#,# + $.#0;} = {0:$#,#.00}", num );
            }

		}
	}
}
