using System;

namespace _6_Substrings
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
            TestSubString();
            TestCopyTo();   
            TestReplace();
            TestSplit();
		}

        static void TestSubString()
        {
            string source = "ABCD1234WXYZ";
            string dest = source.Substring( 4, 4 );
            Console.WriteLine( "{0}\n", dest );
        }

        static void TestCopyTo()
        {
            string source = "ABCD";
            char [] dest = { '1', '2', '3', '4', '5', '6', '7', '8' };

            Console.Write( "Char array before = " );
            Console.WriteLine( dest );

            // copy substring into char array
            source.CopyTo( 0, dest, 4, source.Length );

            Console.Write( "Char array after = " );
            Console.WriteLine( dest );

            // copy back into source string
            source = new String( dest );

            Console.WriteLine( "New source = {0}\n", source );
        }

        static void TestReplace()
        {
            string replaceStr = "1234";
            string dest = "ABCDEFGHWXYZ";

            dest = dest.Replace( "EFGH", replaceStr );

            Console.WriteLine( dest );
        }

        static void TestSplit()
        {
            char delim = '\\';
            string filePath = "C:\\Windows\\Temp";
            string [] directories = null;

            directories = filePath.Split( delim );
                
            foreach (string directory in directories) 
            {
                Console.WriteLine("{0}", directory);
            }
        }
	}
}
