using System;
using System.Text;

namespace _7_StringBuilder
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
            // Interned string test
			string sLiteral = "Automatically Interned";
            string sNotInterned = "Not " + sLiteral;

            TestInterned( sLiteral );
            TestInterned( sNotInterned );

            String.Intern( sNotInterned );
            TestInterned( sNotInterned );

            // StringBuilder test
            string string1 = "";
            String string2 = "";

            Console.Write( "Enter string 1: " );
            string1 = Console.ReadLine();
            Console.Write( "Enter string 2: " );
            string2 = Console.ReadLine();
            
            BuildStrings( string1, string2 );
		}
        
        static void TestInterned( string str )
        {
            if( String.IsInterned( str ) != null )
            {
                Console.WriteLine( "The string \"{0}\" is interned.", str );
            }
            else
            {
                Console.WriteLine( "The string \"{0}\" is not interned.", str );
            }
        }

        public static void BuildStrings( string str1, string str2 )
        {
            StringBuilder sb = new StringBuilder( str1 + str2 );
 
            sb.Insert( str1.Length, " is the first string.\n" );
            sb.Insert( sb.Length, " is the second string.\n" );
            
            Console.WriteLine( sb );
        }

	}
}
