using System;
using System.Collections;

namespace _4_ArrayList
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			CreateArrayLists();
            TestArrayList();
		}

        static void CreateArrayLists()
        {
            // demonstrates the 3 constructors of ArrayList
            ArrayList al1 = new ArrayList();
            ArrayList al2 = new ArrayList( 10 );

            int[] intArr = new int[10];
            ArrayList al3 = new ArrayList( intArr );
        }

        static void TestArrayList()
        {
            ArrayList myArrayList = new ArrayList();
            myArrayList.Capacity = 10;

            int[] intArr = {2, 3, 4, 5};
            myArrayList.Add( 1 );
            myArrayList.AddRange( intArr );
            Console.WriteLine( myArrayList.Capacity );

            myArrayList.Remove( 1 );
            myArrayList.RemoveRange( 1, 2 );

            myArrayList.Insert( 1, 3 );
            myArrayList.InsertRange( 0, intArr );

            foreach( object elem in myArrayList )
            {
                Console.WriteLine( elem );
            }
        }
	}
}
