using System;

namespace _1_TryCatch
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
            try
            {
                Console.Write( "Enter a number: ");
                int input = Int32.Parse( Console.ReadLine() );

                for( int i = 5; i >= 0; i-- )
                    Console.WriteLine( "{0}/{1}={2}", input, i, input/i );
            }
            catch( DivideByZeroException )
            {
                Console.WriteLine( "Program attempted to divide by zero" );
            }
            catch( Exception e )
            {
                Console.WriteLine( "An error occured: {0}", e.Message );
            }
            finally
            {
                Console.WriteLine( "Program has finished." );
            }

            Console.WriteLine( "This will get executed." );
		}
	}
}
