using System;
using System.Collections;

namespace _4_CustomException
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
            OddIntCollection oddValues = new OddIntCollection();

            int input = 0;

            do       
            {
                Console.Write( "Enter an odd number or -1 to quit: " );
                input = Int32.Parse( Console.Read().ToString() );

                if( input != -1 )
                    oddValues.Add( input );
                
            } while( input != -1 );
		}
	}

    class OddIntCollection : CollectionBase
    {
        public void Add( int value )
        {
            if( (value & 0x1) == 0 )
            {
                throw new OddIntException();
            }
            else
            {
                InnerList.Add( value );
            }
        }
    }

    class OddIntException : ApplicationException
    {
        public override string Message
        {
            get
            {
                return "Value is not an odd number";
            }
        }

    }
}
