using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Text;

namespace _1_FileView
{
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public class Form1 : System.Windows.Forms.Form
    {
        private System.Windows.Forms.TextBox tbView;
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem menuItem6;
        private System.Windows.Forms.OpenFileDialog openFileDialog1;
        private System.Windows.Forms.SaveFileDialog saveFileDialog1;
        private System.Windows.Forms.MenuItem mnuNew;
        private System.Windows.Forms.MenuItem mnuOpen;
        private System.Windows.Forms.MenuItem mnuSave;
        private System.Windows.Forms.MenuItem mnuSaveAs;
        private System.Windows.Forms.MenuItem muExit;
        private string curFilePath = "Untitled";
        private bool bDirty = false;
        private System.Windows.Forms.MenuItem menuItem2;
        private System.Windows.Forms.MenuItem mnuProperties;
        private System.Windows.Forms.MenuItem mnuTestBin;

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            this.Text = "Simple Pad - " + curFilePath;
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if (components != null) 
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.tbView = new System.Windows.Forms.TextBox();
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.mnuNew = new System.Windows.Forms.MenuItem();
            this.mnuOpen = new System.Windows.Forms.MenuItem();
            this.mnuSave = new System.Windows.Forms.MenuItem();
            this.mnuSaveAs = new System.Windows.Forms.MenuItem();
            this.menuItem6 = new System.Windows.Forms.MenuItem();
            this.muExit = new System.Windows.Forms.MenuItem();
            this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
            this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.mnuProperties = new System.Windows.Forms.MenuItem();
            this.mnuTestBin = new System.Windows.Forms.MenuItem();
            this.SuspendLayout();
            // 
            // tbView
            // 
            this.tbView.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tbView.Location = new System.Drawing.Point(0, 0);
            this.tbView.Multiline = true;
            this.tbView.Name = "tbView";
            this.tbView.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.tbView.Size = new System.Drawing.Size(656, 438);
            this.tbView.TabIndex = 0;
            this.tbView.Text = "";
            this.tbView.TextChanged += new System.EventHandler(this.tbView_TextChanged);
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuItem1,
                                                                                      this.menuItem2});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.mnuNew,
                                                                                      this.mnuOpen,
                                                                                      this.mnuSave,
                                                                                      this.mnuSaveAs,
                                                                                      this.menuItem6,
                                                                                      this.muExit});
            this.menuItem1.Text = "&File";
            // 
            // mnuNew
            // 
            this.mnuNew.Index = 0;
            this.mnuNew.Text = "&New";
            this.mnuNew.Click += new System.EventHandler(this.mnuNew_Click);
            // 
            // mnuOpen
            // 
            this.mnuOpen.Index = 1;
            this.mnuOpen.Text = "&Open";
            this.mnuOpen.Click += new System.EventHandler(this.mnuOpen_Click);
            // 
            // mnuSave
            // 
            this.mnuSave.Index = 2;
            this.mnuSave.Text = "&Save";
            this.mnuSave.Click += new System.EventHandler(this.mnuSave_Click);
            // 
            // mnuSaveAs
            // 
            this.mnuSaveAs.Index = 3;
            this.mnuSaveAs.Text = "Save &As";
            this.mnuSaveAs.Click += new System.EventHandler(this.mnuSaveAs_Click);
            // 
            // menuItem6
            // 
            this.menuItem6.Index = 4;
            this.menuItem6.Text = "-";
            // 
            // muExit
            // 
            this.muExit.Index = 5;
            this.muExit.Text = "&Exit";
            this.muExit.Click += new System.EventHandler(this.mnuExit_Click);
            // 
            // openFileDialog1
            // 
            this.openFileDialog1.Filter = "All Files|*.*";
            // 
            // saveFileDialog1
            // 
            this.saveFileDialog1.Filter = "Text Files|*.txt";
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 1;
            this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.mnuProperties,
                                                                                      this.mnuTestBin});
            this.menuItem2.Text = "&View";
            // 
            // mnuProperties
            // 
            this.mnuProperties.Index = 0;
            this.mnuProperties.Text = "&Properties";
            this.mnuProperties.Click += new System.EventHandler(this.mnuProperties_Click);
            // 
            // mnuTestBin
            // 
            this.mnuTestBin.Index = 1;
            this.mnuTestBin.Text = "Test Binary Write/Read";
            this.mnuTestBin.Click += new System.EventHandler(this.mnuTestBin_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(656, 438);
            this.Controls.Add(this.tbView);
            this.Menu = this.mainMenu1;
            this.Name = "Form1";
            this.Text = "File Viewer";
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main() 
        {
            Application.Run(new Form1());
        }

        private void mnuNew_Click(object sender, System.EventArgs e)
        {
            if( bDirty == true )
            {
                // prompt for save
            }

            tbView.Text = "";
            bDirty = false;
            curFilePath = "Untitled";
            this.Text = "Simple Pad - " + curFilePath;
            
        }

        private void mnuOpen_Click(object sender, System.EventArgs e)
        {
            if( bDirty == true )
            {
                if( MessageBox.Show( "The text in the file has changed.\nWould you like to save your changes?", 
                    "Save?", MessageBoxButtons.YesNo, MessageBoxIcon.Question ) == DialogResult.Yes )
                {
                    mnuSave_Click( sender, e );
                }
            }

            if( openFileDialog1.ShowDialog(this) == DialogResult.OK )
            {
                // set textbox to file contents   
                tbView.Text = OpenText( openFileDialog1.FileName );
    
                // set current filename
                curFilePath = openFileDialog1.FileName;

                // reset title
                this.Text = "Simple Pad - " + curFilePath;

                // not dirty anymore
                bDirty = false;
            }
        }

        private void mnuSave_Click(object sender, System.EventArgs e)
        {
            if( curFilePath == "Untitled" && bDirty == true )
            {
                mnuSaveAs_Click( sender, e );
                return;
            }

            // backup the file
            File.Copy( curFilePath, "bkup.bak", true );

            // save it
            SaveText( tbView.Text, curFilePath );
        }

        private void mnuSaveAs_Click(object sender, System.EventArgs e)
        {
            if( saveFileDialog1.ShowDialog(this) == DialogResult.OK )
            {
                // back up the file first
                File.Copy( curFilePath, "bkup.bak", true );

                // save to new file
                SaveText( tbView.Text, saveFileDialog1.FileName );
                curFilePath = saveFileDialog1.FileName;
                bDirty = false;
                this.Text = "Simple Pad - " + curFilePath;
            }
        }

        private void mnuExit_Click(object sender, System.EventArgs e)
        {
		
        }

        private void tbView_TextChanged(object sender, System.EventArgs e)
        {
            if( bDirty == false )
            {
                bDirty = true;

                this.Text = "Simple Pad - " + curFilePath + " *";

            }
        }

        byte[] TextToByteArray( string text )
        {
            byte[] bytes = new byte[text.Length];
            ASCIIEncoding ascii = new ASCIIEncoding();
            ascii.GetBytes( text, 0, text.Length, bytes, 0 );
            
            return bytes;
        }
           
        private void SaveText( string text, string file )
        {
            StreamWriter sw = null;

            try
            {
                // Check if file exists
                if( File.Exists( file ) )
                {
                    File.Delete( file );
                }

                // Create a new file for text output
                sw = File.CreateText( file );
                sw.Write( text );
            }
            catch( Exception e )
            {
                MessageBox.Show( e.Message );
            }
            finally
            {
                if( sw != null )
                    sw.Close();
            }
        }

        private void SaveBinary( byte[] bytes, string file )
        {
            FileStream fs = null;
            
            try
            {
                if( File.Exists( file ) )
                {
                    File.Delete(file);
                }

                //Create a new file for binary output
                fs = File.Create( file );
                fs.Write( bytes, 0, bytes.Length );
            }
            catch( Exception e )
            {
                MessageBox.Show( e.Message );
            }
            finally
            {
                if( fs != null )
                    fs.Close();
            }
        }

        private void TestBinaryWrite( string file )
        {
            FileStream fs = null;
            BinaryWriter bw;
          
            try
            {
                // open the file
                fs = File.Open( file, FileMode.Create );
                bw = new BinaryWriter( fs );
                
                // write 5 integers
                for( int i = 0; i < 5; ++i )
                {
                    bw.Write(i);
                }

                // write 5 string
                for( int i = 0; i < 5; ++i )
                {
                    bw.Write( "string" + i.ToString() );
                }
            }
            catch( Exception e )
            {
                MessageBox.Show( e.Message );
            }
            finally
            {
                // close the FileStream
                if( fs != null )
                    fs.Close();
            }

            return;
        }

        private void TestBinaryRead( string file )
        {
            FileStream fs = null;
            BinaryReader br;
            int[] intData = new int[5];
            string[] strData = new string[5];

            try
            {
                // open the file
                fs = File.OpenRead( file );
                br = new BinaryReader( fs );

                // read 5 integers
                for( int i = 0; i < 5; ++i )
                {
                    intData[i] = br.ReadInt32();
                }

                // read 5 string
                for( int i = 0; i < 5; ++i )
                {
                    strData[i] = br.ReadString();
                }
            }
            catch( Exception e )
            {
                MessageBox.Show( e.Message );
            }
            finally
            {
                // close the FileStream
                if( fs != null )
                    fs.Close();
            }

            // display data
            StringBuilder sb = new StringBuilder();
            
            sb.Append( "Int Data: " );
            for( int i = 0; i < 5; ++i ) sb.Append( intData[i].ToString() + " " );
            
            sb.Append( "\nString Data: " );
            for( int i = 0; i < 5; ++i ) sb.Append( strData[i] + " " );
            
            MessageBox.Show( sb.ToString() );
            return;
        }

        string CharArrayToString( char[] bytes )
        {
            ASCIIEncoding ascii = new ASCIIEncoding();
            return ascii.GetString( (byte[])bytes.Clone(), 0, bytes.Length );
        }

        private string ReadUsingBlocks( string file )
        {
            StreamReader sr = null;
            char[] tempBuffer = new char[10];
            StringBuilder result = new StringBuilder("");
    
            try
            {
                sr = File.OpenText( file );
                while( sr.Read( tempBuffer, 0, 12 ) != 0 )
                {
                    result.Append(tempBuffer);
                }
            }
            catch( Exception e )
            {
                MessageBox.Show( e.Message );
            }
            finally
            {
                // close streamreader
                if( sr != null )
                    sr.Close();
            }

            return result.ToString();

        }
        private string OpenText( string file )
        {
            StreamReader sr = null;
            string contents = "";

            try
            {
                // open the file
                sr = File.OpenText( file );
                contents = sr.ReadToEnd();
                
            }
            catch( Exception e )
            {
                MessageBox.Show( e.Message );
            }
            finally
            {
                // close the StreamReader
                if( sr != null )
                    sr.Close();
            }

            // placeholder
            return contents;
        }

        private void mnuProperties_Click(object sender, System.EventArgs e)
        {
            if( curFilePath == "Untitled" ) return;
            FileProperties fp = new FileProperties( curFilePath );
            MessageBox.Show( fp.ToString(), "Properties" );
        }

        private void mnuTestBin_Click(object sender, System.EventArgs e)
        {
            if( saveFileDialog1.ShowDialog() == DialogResult.OK )
            {
                TestBinaryWrite( saveFileDialog1.FileName );
                TestBinaryRead( saveFileDialog1.FileName );
            }
        }
    }

    public class FileProperties
    {
        FileInfo fileInfo;

        public FileProperties( string file )
        {
            this.fileInfo = new FileInfo( file );
        }

        public string Attributes
        {
            get
            {
                return "Attributes: " + fileInfo.Attributes.ToString();
            }
        }

        public string CreationTime
        {
            get
            {
                return "Creation Time: " + fileInfo.CreationTime.ToString();;
            }
        }
        
        public string LastAccessTime
        {
            get
            {
                return "Last Access Time: " + fileInfo.LastAccessTime;
            }
        }

        public string LastWriteTime
        {
            get
            {
                return "Last Write Time: " + fileInfo.LastWriteTime;
            }
        }

        public string FileSize
        {
            get
            {
                return "File Size: " + fileInfo.Length;
            }
        }

        public override string ToString()
        {
            string ret;
            ret = "Filename: " + fileInfo.Name + "\n";
            ret += "Directory: " + fileInfo.DirectoryName + "\n";
            ret += this.FileSize + "\n";
            ret += this.Attributes + "\n";
            ret += this.CreationTime + "\n";
            ret += this.LastAccessTime + "\n";
            ret += this.LastWriteTime + "\n";

            return ret;
        }
    }
}
