using System;
using System.IO;

namespace _6_ReadOnly
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
            if( args.Length <= 0 || args.Length > 2 )
            {
                DisplayUsage();
                return;
            }

            if( File.Exists( args[0] ) == false )
            {
                DisplayUsage();
                return;
            }

            if( args[1] == "+r" )
            {
                File.SetAttributes( args[0], File.GetAttributes(args[0]) | FileAttributes.ReadOnly );
            }
            else if( args[1] == "-r" )
            {
                File.SetAttributes( args[0], File.GetAttributes(args[0]) & (~FileAttributes.ReadOnly) );
            }
            else
            {
                DisplayUsage();
                return;
            }
		}

        static void DisplayUsage()
        {
            Console.WriteLine( "Usage: ro <filename> (+r|-r)\n" );
        }
	}
}
