using System;
using System.IO;

namespace _9_AppendText
{
    /// <summary>
    /// Summary description for Class1.
    /// </summary>
    class Class1
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            if( args.Length <= 0 || args.Length > 2 )
            {
                DisplayUsage();
                return;
            }

            if( File.Exists( args[0] ) == false )
            {
                DisplayUsage();
                return;
            }

            StreamWriter sw = File.AppendText( args[0] );
            sw.Write( args[1] );

            sw.Close();
            return;
        }

        static void DisplayUsage()
        {
            Console.WriteLine( "Usage: append <filename> \"<text>\"\n" );
        }
    }
}
