using System;
using System.Data;
using System.Data.SqlClient;

namespace _11_DynamicDataSet
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
            SqlConnection connection;
            SqlDataAdapter dataAdapter;
            DataSet productsDS;
            SqlCommandBuilder commandBuilder;
            SqlCommand selectCommand;

            string connectionString = "Integrated Security=SSPI;Data Source=VCSMARKHSCH6;Initial Catalog=Northwind;";
            string selectCmd = "SELECT * From Products";
            
            // create new SqlConnection specifying the connectino string
            connection = new SqlConnection( connectionString );

            // create new dataset object and data adapter used to fill it
            productsDS = new DataSet();
            selectCommand = new SqlCommand( selectCmd, connection );
            dataAdapter = new SqlDataAdapter( selectCommand );     

            // create command builder
            commandBuilder = new SqlCommandBuilder( dataAdapter );

            // open the connection
            connection.Open();

            // fill the dataset from products table
            dataAdapter.Fill(productsDS, "Products" );

            DataTable tbl = productsDS.Tables.Add( "JustaTest" );
            tbl.Columns.Add( "Column1" );
            tbl.Columns.Add( "Column2" );
            tbl.Columns.Add( "Column3" );

            dataAdapter.Update( productsDS, "JustaTest" );
		}
	}
}
