using System;
using System.Collections;
using System.Data.SqlClient;
using System.Diagnostics;

namespace _21_ConnectionPooling
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
            char input;
            ArrayList connectionArray = new ArrayList();;
            string connectionString = "Integrated Security=SSPI;Initial Catalog=northwind;Connection Lifetime=1";
            SqlConnection connection;
            //PerformanceCounter pooledConnection = new PerformanceCounter( 
            do
            {
                Console.WriteLine( "C)reate new connection" );
                Console.WriteLine( "C(l)ose a connection" );
                Console.WriteLine( "V)iew connection pooling information" );
                Console.WriteLine( "Q)uit" );
                Console.Write( "Enter a command: " );
                
                input = Char.ToUpper(Console.ReadLine()[0]);
                switch( input )
                {
                    case( 'C' ):
                    {
                        connection = new SqlConnection(connectionString);
                        connection.Open();
                        connectionArray.Add( connection );
                        break;
                    }
                    case( 'L' ):
                    {
                        if( connectionArray.Count > 0 )
                        {
                            ((SqlConnection) connectionArray[connectionArray.Count-1]).Close();
                            connectionArray.RemoveAt( connectionArray.Count-1 );
                        }
                        break;
                    }
                    case( 'V' ):
                    {
                        break;
                    }
                    case( 'Q' ):
                    {
                        break;
                    }
                    default:
                    {
                        Console.WriteLine( "Invalid command" );
                        break;
                    }
                }
            } while( input != 'Q' );

            foreach( object o in connectionArray )
            {
                ((SqlConnection)o).Close();
            }
		}
	}
}
