// CommandCom.cpp : Implementation of CCommandCom

#include "stdafx.h"
#include "CommandCom.h"
#include ".\commandcom.h"
#include <atlfile.h>
#include <atlsafe.h>

// CCommandCom

void GetResult( LPTSTR fileName, BSTR* Result )
{
    USES_CONVERSION;

    CAtlFile file;
    ULONGLONG len;
    LPBYTE lpBuffer;

    // read file into buffer
    HRESULT hr = file.Create( fileName, FILE_SHARE_READ, 0, OPEN_EXISTING );
    hr = file.GetSize( len );
    lpBuffer = new BYTE[len];
    hr = file.Read( lpBuffer, len );
    file.Close();

    *(lpBuffer+len) = '\0';

    // set return value
    *(Result) = SysAllocString( T2OLE((LPTSTR)lpBuffer) );

    return;
}

STDMETHODIMP CCommandCom::get_CurrentDirectory(BSTR* pVal)
{
    USES_CONVERSION;

    TCHAR szBuffer[ MAX_PATH ];

    GetCurrentDirectory( MAX_PATH, szBuffer );

    *(pVal) = SysAllocString( T2OLE(szBuffer) );

    return S_OK;
}

STDMETHODIMP CCommandCom::put_CurrentDirectory(BSTR newVal)
{
    return E_NOTIMPL;
}

STDMETHODIMP CCommandCom::RunCommand(BSTR Cmd, BSTR Params, BSTR* Result)
{
    USES_CONVERSION;

    CString finalCmd;
    finalCmd.Format( "%s %s 1<&2 >\"%s\"", OLE2T(Cmd), OLE2T(Params), mTempFileName );

    system( finalCmd );

    GetResult( mTempFileName, Result );

    return S_OK;
}

STDMETHODIMP CCommandCom::Test()
{
    __raise SomeEvent();

    return S_OK;
}

STDMETHODIMP CCommandCom::Run(BSTR Cmd, BSTR* Output)
{
    USES_CONVERSION;

    CString finalCmd;
    finalCmd.Format( "%s 1<&2 >\"%s\"", OLE2T(Cmd), mTempFileName );

    system( finalCmd );

    GetResult( mTempFileName, Output );

    return S_OK;
}

STDMETHODIMP CCommandCom::ProcessCommands(SAFEARRAY * Commands, BSTR* Output )
{
    CComSafeArray<BSTR> arr;
    CComBSTR finalResult;
    CComBSTR tempResult;

    arr.Attach( Commands );
    for( int i = 0; i < arr.GetCount(); ++i )
    {
        BSTR cmd = arr.GetAt(i);
        Run( cmd, &tempResult );
        finalResult.Append( tempResult );
    }

    *(Output) = finalResult.Copy();

    return S_OK;
}
