// AirVehicle.h : Declaration of the CAirVehicle

#pragma once
#include "resource.h"       // main symbols


// IAirVehicle
[
	object,
	uuid("01D40278-1C46-47F6-BB38-5D7E244C2B2C"),
	dual,	helpstring("IAirVehicle Interface"),
	pointer_default(unique)
]
__interface IAirVehicle : IDispatch
{
    [propget, id(1), helpstring("property Wings")] HRESULT Wings([out, retval] int* pVal);
    [propput, id(1), helpstring("property Wings")] HRESULT Wings([in] int newVal);
    [id(2), helpstring("method ElevationUp")] HRESULT ElevationUp([in] int Amount, [out,retval] int* Elevation);
};



// CAirVehicle

[
	coclass,
	threading("apartment"),
	vi_progid("ComObject.AirVehicle"),
	progid("ComObject.AirVehicle.1"),
	version(1.0),
	uuid("3BC18B4B-C5AC-4D89-8D12-9552626EA831"),
	helpstring("AirVehicle Class")
]
class ATL_NO_VTABLE CAirVehicle : 
	public IAirVehicle
{
public:
	CAirVehicle()
	{
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:

    STDMETHOD(get_Wings)(int* pVal);
    STDMETHOD(put_Wings)(int newVal);
    STDMETHOD(ElevationUp)(int Amount, int* Elevation);
};

