using System;
using System.Text;

namespace _1_UsingStrings
{
    class Class1
    {
        [STAThread]
        static void Main(string[] args)
        {
            string string1 = "";
            String string2 = "";

            Console.Write( "Enter string 1: " );
            string1 = Console.ReadLine();
            Console.Write( "Enter string 2: " );
            string2 = Console.ReadLine();
            
            // string and String are the same types
            Console.WriteLine( "string1 is a {0}\nstring2 is a {1}", string1.GetType().FullName, string2.GetType().FullName );

            CompareStrings( string1, string2 );

            BuildStrings( string1, string2 );
        }

        public static void CompareStrings( string str1, string str2 )
        {
            int compare = String.Compare( str1, str2 );
            
            if( compare == 0 )
                Console.WriteLine( "The strings {0} and {1} are the same.\n", str1, str2 );
            else if( compare < 0 )
                Console.WriteLine( "The string {0} is less than {1}", str1, str2 );
            else if( compare > 0 )
                Console.WriteLine( "The string {0} is greater than {1}", str1, str2 );
        }

        public static void BuildStrings( string str1, string str2 )
        {
            StringBuilder sb = new StringBuilder( str1 + str2 );
            sb.Insert( str1.Length, " is the first string.\n" );
            sb.Insert( sb.Length, " is the second string.\n" );

            Console.WriteLine( sb );
        }
    }
}
