using System;
using System.Drawing;

namespace _11_ResourceObjects
{
    [Serializable]
    public class ImageWithCaption
    {
        public string caption;
        public Image image;

        public ImageWithCaption( string caption, Image image )
        {
            this.caption = caption;
            this.image = image;
        }

        public string Caption
        {
            get
            {
                return this.caption;
            }
            set
            {
                this.caption = value;
            }
        }

        public Image Picture
        {
            get
            {
                return this.image;
            }
            set
            {
                this.image = value;
            }
        }
    }
}
