using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace _12_ApplicationState
{
    /// <summary>
    /// Summary description for WebForm1.
    /// </summary>
    public class WebForm1 : System.Web.UI.Page
    {
        protected System.Web.UI.WebControls.TextBox tbTranscript;
        protected System.Web.UI.WebControls.TextBox tbMessage;
        protected System.Web.UI.WebControls.Button btnSend;
    
        private void Page_Load(object sender, System.EventArgs e)
        {
            RefreshTranscript();   
        }

        #region Web Form Designer generated code
        override protected void OnInit(EventArgs e)
        {
            InitializeComponent();
            base.OnInit(e);
        }
	
        private void InitializeComponent()
        {    
            this.btnSend.Click += new System.EventHandler(this.btnSend_Click);
            this.Load += new System.EventHandler(this.Page_Load);

        }
        #endregion

        public void RefreshTranscript()
        {
            int msgID = 0;
            string transcript = "";

            while( Application[msgID.ToString()] != null )
            {
                transcript += Application[msgID.ToString()].ToString() + "\r\n";
                msgID++;
            }

            tbTranscript.Text = transcript;
        }

        private void btnSend_Click(object sender, System.EventArgs e)
        {
            int lastMsgID;

            if( Application["lastMsgID"] == null )
            {
                lastMsgID = 0;
            }
            else
            {
                lastMsgID = Int32.Parse( Application["lastMsgID"].ToString() ) + 1;
            }

            Application[lastMsgID.ToString()] = Session.SessionID.ToString() + ": " + tbMessage.Text;
            Application["lastMsgID"] = lastMsgID.ToString();

            RefreshTranscript();
        }
    }
}
