using System;
using System.Text;
namespace _11_NotepadPlugins
{
    public class Rot13 : _11_NotepadPluginSDK.INotepadPlugin
    {
        public string Name
        {
            get
            {
                return "Rot13";

            }
        }

        public string Execute(string selection)
        {
            char[] chars = selection.ToCharArray( 0, selection.Length );
            for( int i = 0; i < chars.Length; i++ )
            {
                if( chars[i] != '\r' && chars[i]!= '\n' )
                    chars[i] += (char)13;
            }
            return new StringBuilder().Append(chars).ToString();
        }
    }

    public class UnRot13 : _11_NotepadPluginSDK.INotepadPlugin
    {
        public string Name
        {
            get
            {
                return "UnRot13";

            }
        }

        public string Execute(string selection)
        {
            char[] chars = selection.ToCharArray( 0, selection.Length );
            for( int i = 0; i < chars.Length; i++ )
            {
                if( chars[i] != '\r' && chars[i]!= '\n' )
                    chars[i] -= (char)13;
            }
            return new StringBuilder().Append(chars).ToString();
        }
    }

    public class Reverser : _11_NotepadPluginSDK.INotepadPlugin
    {
        public string Name
        {
            get
            {
                return "Reverser";

            }
        }

        public string Execute(string selection)
        {
            char[] chars = selection.ToCharArray();
            Array.Reverse(chars);

            // fix \r\n reversal
            for( int i = 0; i < chars.Length; i++ )
            {
                if( chars[i] == '\r' ) chars[i] = '\n';
                else if( chars[i] == '\n' ) chars[i] = '\r';
            }
            return new StringBuilder().Append(chars).ToString();      
        }
    }
}
