// MessageWindowNative.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "MessageWindowNative.h"

#ifdef MESSAGEWINDOWNATIVE_EXPORTS
#define MESSAGEWINDOWNATIVE_API __declspec(dllexport)
#else
#define MESSAGEWINDOWNATIVE_API __declspec(dllimport)
#endif


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

#define WM_USER_ADDWINDOW WM_USER + 1

BOOL CALLBACK EnumWindowsProc( HWND hwnd, LPARAM lParam )
{
	WPARAM wParam = 0;

	if( GetParent( hwnd ) != NULL )
		wParam = 1;

	PostMessage( (HWND) lParam, WM_USER_ADDWINDOW, wParam, (LPARAM) hwnd );

	return TRUE;
}

extern "C"
{

	MESSAGEWINDOWNATIVE_API void EnumerateDeviceWindows( HWND hCallbackWnd )
	{
		EnumWindows( EnumWindowsProc, (LPARAM) hCallbackWnd );
	}
}

